KIO::Scheduler Class Reference

`#include <scheduler.h>`

Inherits QObject, and DCOPObject.

## Public Types

typedef QPtrList< SimpleJob > | JobList

## Public Slots

void | slotSlaveDied (KIO::Slave *slave)
void | slotSlaveStatus (pid_t pid, const QCString &protocol, const QString &host, bool connected)

## Signals

void | slaveConnected (KIO::Slave *slave)
void | slaveError (KIO::Slave *slave, int error, const QString &errorMsg)

## Public Member Functions

bool | connect (const QObject *sender, const char *signal, const char *member)
void | debug_info ()
virtual bool | process (const QCString &fun, const QByteArray &data, QCString &replyType, QByteArray &replyData)
virtual QCStringList | functions ()

## Static Public Member Functions

static void | doJob (SimpleJob *job)
static void | scheduleJob (SimpleJob *job)
static void | cancelJob (SimpleJob *job)
static void | jobFinished (KIO::SimpleJob *job, KIO::Slave *slave)
static void | putSlaveOnHold (KIO::SimpleJob *job, const KURL &url)
static void | removeSlaveOnHold ()
static void | publishSlaveOnHold ()
static KIO::Slave * | getConnectedSlave (const KURL &url, const KIO::MetaData &config=MetaData())
static bool | assignJobToSlave (KIO::Slave *slave, KIO::SimpleJob *job)
static bool | disconnectSlave (KIO::Slave *slave)
static void | registerWindow (QWidget *wid)
static void | unregisterWindow (QObject *wid)
static bool | connect (const char *signal, const QObject *receiver, const char *member)
static bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *member)
static bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *member)
static void | checkSlaveOnHold (bool b)

## Protected Slots

void | startStep ()
void | slotCleanIdleSlaves ()
void | slotSlaveConnected ()
void | slotSlaveError (int error, const QString &errorMsg)
void | slotScheduleCoSlave ()
void | slotUnregisterWindow (QObject *)

## Protected Member Functions

void | setupSlave (KIO::Slave *slave, const KURL &url, const QString &protocol, const QString &proxy, bool newSlave, const KIO::MetaData *config=0)
bool | startJobScheduled (ProtocolInfo *protInfo)
bool | startJobDirect ()
virtual void | virtual_hook (int id, void *data)

## Detailed Description

The KIO::Scheduler manages io-slaves for the application.

It also queues jobs and assigns the job to a slave when one becomes available.

There are 3 possible ways for a job to get a slave:

### 1. Direct

This is the default. When you create a job the KIO::Scheduler will be notified and will find either an existing slave that is idle or it will create a new slave for the job.

Example:

TransferJob *job = KIO::get(KURL("http://www.kde.org"));

### 2. Scheduled

If you create a lot of jobs, you might want not want to have a slave for each job. If you schedule a job, a maximum number of slaves will be created. When more jobs arrive, they will be queued. When a slave is finished with a job, it will be assigned a job from the queue.

Example:

TransferJob *job = KIO::get(KURL("http://www.kde.org"));
KIO::Scheduler::scheduleJob(job);

### 3. Connection Oriented

For some operations it is important that multiple jobs use the same connection. This can only be ensured if all these jobs use the same slave.

You can ask the scheduler to open a slave for connection oriented operations. You can then use the scheduler to assign jobs to this slave. The jobs will be queued and the slave will handle these jobs one after the other.

Example:

Slave *slave = KIO::Scheduler::getConnectedSlave(
KURL("pop3://bastian:password@mail.kde.org"));
TransferJob *job1 = KIO::get(
KURL("pop3://bastian:password@mail.kde.org/msg1"));
KIO::Scheduler::assignJobToSlave(slave, job1);
TransferJob *job2 = KIO::get(
KURL("pop3://bastian:password@mail.kde.org/msg2"));
KIO::Scheduler::assignJobToSlave(slave, job2);
TransferJob *job3 = KIO::get(
KURL("pop3://bastian:password@mail.kde.org/msg3"));
KIO::Scheduler::assignJobToSlave(slave, job3);
// ... Wait for jobs to finish...
KIO::Scheduler::disconnectSlave(slave);

Note that you need to explicitly disconnect the slave when the connection goes down, so your error handler should contain:

if (error == KIO::ERR_CONNECTION_BROKEN)
KIO::Scheduler::disconnectSlave(slave);

See also
  KIO::Slave
  KIO::Job

Definition at line 111 of file scheduler.h.

## Member Function Documentation

static void KIO::Scheduler::cancelJob | ( | SimpleJob * | job | ) |

inline static

Stop the execution of a job.

Parameters

  job | the job to cancel

Definition at line 145 of file scheduler.h.

static void KIO::Scheduler::checkSlaveOnHold | ( | bool | b | ) |

inline static

When true, the next job will check whether KLauncher has a slave on hold that is suitable for the job.

Parameters

  b | true when KLauncher has a job on hold

Definition at line 280 of file scheduler.h.

static bool KIO::Scheduler::connect | ( | const char * | signal,
|  | const QObject * | receiver,
|  | const char * | member
| ) |  |

inline static

Function to connect signals emitted by the scheduler.

See also
  slaveConnected()
  slaveError()

Definition at line 259 of file scheduler.h.

static void KIO::Scheduler::doJob | ( | SimpleJob * | job | ) |

inline static

Register `job` with the scheduler.

The default is to create a new slave for the job if no slave is available. This can be changed by calling scheduleJob.

Parameters

  job | the job to register

Definition at line 129 of file scheduler.h.

static KIO::Slave* KIO::Scheduler::getConnectedSlave | ( | const KURL & | url,
|  | const KIO::MetaData & | config = `MetaData()`
| ) |  |

inline static

Requests a slave for use in connection-oriented mode.

Parameters

  url | This defines the username,password,host & port to connect with.
  config | Configuration data for the slave.

Returns
  A pointer to a connected slave or 0 if an error occurred.

See also
  assignJobToSlave()
  disconnectSlave()

Definition at line 196 of file scheduler.h.

static void KIO::Scheduler::jobFinished | ( | KIO::SimpleJob * | job,
|  | KIO::Slave * | slave
| ) |  |

inline static

Called when a job is done.

Parameters

  job | the finished job
  slave | the slave that executed the `job`

Definition at line 153 of file scheduler.h.

static void KIO::Scheduler::publishSlaveOnHold | ( |  | ) |

inline static

Send the slave that was put on hold back to KLauncher.

This allows another process to take over the slave and resume the job that was started.

Definition at line 182 of file scheduler.h.

static void KIO::Scheduler::putSlaveOnHold | ( | KIO::SimpleJob * | job,
|  | const KURL & | url
| ) |  |

inline static

Puts a slave on notice.

A next job may reuse this slave if it requests the same URL.

A job can be put on hold after it has emit'ed its mimetype. Based on the mimetype, the program can give control to another component in the same process which can then resume the job by simply asking for the same URL again.

Parameters

  job | the job that should be stopped
  url | the URL that is handled by the `url`

Definition at line 167 of file scheduler.h.

static void KIO::Scheduler::registerWindow | ( | QWidget * | wid | ) |

inline static

Send the slave that was put on hold back to KLauncher.

This allows another process to take over the slave and resume the job the that was started. Register the mainwindow `wid` with the KIO subsystem Do not call this, it is called automatically from void KIO::Job::setWindow(QWidget*).

Parameters

  wid | the window to register

Since
  3.1

Definition at line 243 of file scheduler.h.

static void KIO::Scheduler::removeSlaveOnHold | ( |  | ) |

inline static

Removes any slave that might have been put on hold.

If a slave was put on hold it will be killed.

Definition at line 174 of file scheduler.h.

static void KIO::Scheduler::scheduleJob | ( | SimpleJob * | job | ) |

inline static

Calling ths function makes that `job` gets scheduled for later execution, if multiple jobs are registered it might wait for other jobs to finish.

Parameters

  job | the job to schedule

Definition at line 138 of file scheduler.h.

void Scheduler::slotUnregisterWindow | ( | QObject * | obj | ) |

protected slot

Since
  3.1

Definition at line 888 of file scheduler.cpp.

The documentation for this class was generated from the following files:

- scheduler.h
- scheduler.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys